<?php

class AddresstypeModel {
  private $table = "Addresstype";
  
  public $address_id = null;
  public $type = null;
  public $primary = null;
  public $note = null;
  
  public $create_by = null;
  public $edit_by = null;
  public $create = null;
  public $edit = null;
  
  public static function create(Array $data) {
    $model = new Addresstype();
    
    foreach($data as $field => $value) {
      if(property_exists(get_called_class(), $field)) {
        $model->$field = $value;
      }
    }
    
    $me = new User();
    $me->loadMe();

    if($model->create_by === null) {
      $model->create_by = $me->id;
    }
    if($model->edit_by === null) {
      $model->edit_by = $me->id;
    }

    return $model;
  }
  
  public static function getOne($id) {
    if(!is_numeric($id) || !$id) {
      throw new Exception("Invalid number", 400);
    }
    $item = [];
    $db = FronkDB::singleton();
    
    $res = $db->select($this->table, "*", "id=$id LIMIT 1");
    if($db->num_rows($res)) {
      $data = $db->fetch_object($res);
      $item = new Addresstype($data);
    }
    return $item;
  }
  
  public static function getAll() {
    $items = [];
    
    $db = FronkDB::singleton();
    
    $res = $db->select($this->table, "*");
    if($db->num_rows($res)) {
      while($data = $db->fetch_object($res)) {
        $items[] = new Addresstype($data);
      }
    }
    return $items;
    
  }
  
  public static function getFirst($filter) {
    $db = FronkDB::singleton();

    $where = self::getSqlFilter($filter);
    $sql = "SELECT Addresstype.* FROM Addresstype
            WHERE $where
            ORDER BY address_id ASC, `primary` DESC, type ASC";

    $res = $db->query($sql);
    if($db->num_rows($res)) {
      $data = $db->fetch_object($res);
      $item = new NetworkAddress($data);
      if($item->id) {
        return $item;
      } else {
        return null;
      }
    }
    return null;
  }
  
  public static function search($filter, $indexByType = false) {
    $items = [];
    $db = FronkDB::singleton();
    
    $where = self::getSqlFilter($filter);
    $sql = "SELECT Addresstype.* FROM Addresstype
            WHERE $where
            ORDER BY address_id ASC, `primary` DESC, type ASC";
    //var_dump($sql);exit;
    $res = $db->query($sql);
    if($db->num_rows($res)) {
      while($data = $db->fetch_object($res)) {
        if($indexByType) {
          $items[$data->type] = new Addresstype($data);
        } else {
          $items[] = new Addresstype($data);
        }
      }
    }
    return $items;
  }
  
  private function getSqlFilter($filter) {
    $where = "1=1 ";
    
    /*
     * Address Type
     */
    if(is_array($filter['addresstype']) && count($filter['addresstype'])) {
      $at = $filter['addresstype'];
      $in = [];
      foreach(TT_ROLES as $role) {
        if(in_array($role, $at)) {
          $in[] = "Addresstype.type = '$role'";
        }
      }
      
      $or = "";
      if(count($in)) {
        $or = implode(" OR ", $in);
        $where .= " AND ( $or )";
      }
    }
    
    if(array_key_exists("address_id", $filter)) {
      $address_id = $filter['address_id'];
      if(!is_numeric($address_id) || !$address_id) {
        return false;
      }
      
      $where .= " AND address_id=$address_id";
    }
    
    return $where;
  }
}